catalog/urls.py
from django.conf.urls import url
from .views import *
from django.contrib.auth import views
app_name='catalog'
urlpatterns=[

    url(r'^index/$',index.as_view(),name='index'),

    url(r'^movieslist/$', MovieFilterView.as_view(), name='movies'),
    url(r'^movies/$',MovieListView.as_view(),name='movielist'),
    url(r'^movies/(?P<pk>\d+)/$', MovieView.as_view(),name='movieedit'),
    url(r'^genres/$', GenresListView.as_view(),name='genreslist'),
    url(r'^genresshow/(?P<pk>\d+)/$', GenresShowView.as_view(),name='genresshow'),
    url(r'^genres/(?P<pk>\d+)/$', GenresView.as_view(),name='genresedit'),





]

drfapi/urls.py
from django.conf.urls import url,include
from django.contrib import admin
from rest_framework.authtoken.views import obtain_auth_token
from catalog.views import index

urlpatterns = [
    url(r'^admin/', admin.site.urls),
    url(r'^api/', include('catalog.urls')),
    url(r'^api-token-auth/', obtain_auth_token),
    url(r'^api-auth/', include('rest_framework.urls', namespace='rest_framework')),
    url(r'', index.as_view(), name='index-home'),



]

catalog/models.py
# -*- coding: utf-8 -*-
from __future__ import unicode_literals

from django.db import models

types=[(u'biography', u'Biography'), (u'horror', u'Horror'), (u'crime', u'Crime'), (u'romance', u'Romance'), (u'sport', u'Sport'), (u'animation', u'Animation'), (u'adult', u'Adult'), (u'adventure', u'Adventure'), (u'news', u'News'), (u'western', u'Western'), (u'comedy', u'Comedy'), (u'reality-tv', u'Reality-TV'), (u'thriller', u'Thriller'), (u'short', u'Short'), (u'sci-fi', u'Sci-Fi'), (u'horror', u'Horror'), (u'film-noir', u'Film-Noir'), (u'mystery', u'Mystery'), (u'history', u'History'), (u'musical', u'Musical'), (u'drama', u'Drama'), (u'adventure', u'Adventure'), (u'action', u'Action'), (u'documentary', u'Documentary'), (u'thriller', u'Thriller'), (u'western', u'Western'), (u'mystery', u'Mystery'), (u'short', u'Short'), (u'family', u'Family'), (u'talk-show', u'Talk-Show'), (u'film-noir', u'Film-Noir'), (u'drama', u'Drama'), (u'action', u'Action'), (u'documentary', u'Documentary'), (u'musical', u'Musical'), (u'fantasy', u'Fantasy'), (u'family', u'Family'), (u'talk-show', u'Talk-Show'), (u'crime', u'Crime'), (u'fantasy', u'Fantasy'), (u'game-show', u'Game-Show'), (u'music', u'Music'), (u'comedy', u'Comedy'), (u'war', u'War'), (u'biography', u'Biography'), (u'romance', u'Romance')]


class Movie(models.Model):
    name = models.CharField(max_length=255)
    director = models.CharField(max_length=255)
    imdb_score = models.DecimalField(decimal_places=2, max_digits=4)
    popularity= models.DecimalField(decimal_places=2, max_digits=4)

    def __unicode__(self):
        return '{}'.format(self.name)

class Genre(models.Model):
    movie = models.ForeignKey(Movie, related_name='genres',on_delete=models.CASCADE)
    category = models.CharField(max_length=255,choices=types)

    def __unicode__(self):
        return '{}'.format(self.category)

catalog/views.py
# -*- coding: utf-8 -*-
from __future__ import unicode_literals
from .serializers import MovieSerializer,GenreSerializer
from rest_framework.views import APIView
from django.shortcuts import render
from .models import *
from rest_framework.response import Response
from rest_framework import status
from rest_framework import generics
from .permissions import *
from django_filters.rest_framework import DjangoFilterBackend
from rest_framework.authentication import SessionAuthentication, BasicAuthentication
from rest_framework.renderers import TemplateHTMLRenderer
from rest_framework.pagination import PageNumberPagination
# Create your views here.
'''class MovieList(APIView):
    permission_classes = (IsAdminOrReadOnly,)
    def get(self, request, format=None):
        movies = Movie.objects.all()
        serializer = MovieSerializer(movies, many=True)
        return Response(serializer.data)

    def post(self, request, format=None):
        serializer = MovieSerializer(data=request.data)
        if serializer.is_valid():
            serializer.save()
            return Response(serializer.data, status=status.HTTP_201_CREATED)
        return Response(serializer.errors, status=status.HTTP_400_BAD_REQUEST)

class MovieCreate(generics.ListCreateAPIView):
    queryset = Movie.objects.all()
    serializer_class = MovieSerializer'''


class MoviePagination(PageNumberPagination):
    page_size = 10

class MovieFilterView(generics.ListAPIView):
    queryset = Movie.objects.all()
    serializer_class = MovieSerializer
    filter_backends = (DjangoFilterBackend,)
    filter_fields = ('name', 'director','imdb_score','popularity')
    pagination_class = MoviePagination

class MovieListView(generics.ListCreateAPIView):
    queryset = Movie.objects.all()
    serializer_class = MovieSerializer



class MovieView(generics.RetrieveUpdateDestroyAPIView):
    serializer_class = MovieSerializer
    queryset = Movie.objects.all()


class GenresListView(generics.ListCreateAPIView):
    queryset = Genre.objects.all()
    serializer_class = GenreSerializer


class GenresView(generics.RetrieveDestroyAPIView):
    serializer_class = GenreSerializer
    queryset = Genre.objects.all()

class GenresShowView(generics.RetrieveAPIView):
    serializer_class = GenreSerializer
    queryset = Genre.objects.all()


class index(generics.RetrieveAPIView):
    """
    A view that returns a templated HTML representation of a given user.    """

    renderer_classes = (TemplateHTMLRenderer,)

    def get(self, request, *args, **kwargs):
        queryset = Movie.objects.all()
        queryset_gen = Genre.objects.all()

        return Response({'movielist':queryset,'gen':queryset_gen},template_name='index.html')

catalog/templates/index.html
<html>
<head>
  <meta charset="utf-8">
  <meta name="viewport" content="width=device-width, initial-scale=1">
  <link rel="stylesheet" href="https://maxcdn.bootstrapcdn.com/bootstrap/3.3.7/css/bootstrap.min.css">
  <script src="https://ajax.googleapis.com/ajax/libs/jquery/3.3.1/jquery.min.js"></script>
  <script src="https://maxcdn.bootstrapcdn.com/bootstrap/3.3.7/js/bootstrap.min.js"></script>


</head>
<body>
    <div class="navbar navbar-static-top navbar-inverse" role="navigation" aria-label="navbar">
        <div class="container">
            <span><a class='navbar-brand' rel="nofollow" href='#' style="font-family:Luckiest Guy; font-size:x-large;">
                <span class="glyphicon glyphicon-film" style="color:#ffcc00;"></span>&nbsp;<b>MoViEs</b>
                    </a>
            </span>
            <ul class="nav navbar-nav pull-right">

                <li class="dropdown">
                    {% if user.is_authenticated %}
                        <a href="#" class="dropdown-toggle log" data-toggle="dropdown" role="button" aria-haspopup="true" aria-expanded="false">
                        <span class="glyphicon glyphicon-user"></span> {{ user.username }}
                        <span class="caret"></span></a>
                        <ul class="dropdown-menu">
                        <li><a href="/api-auth/logout/"><b>logout</b></a>
                        </li>
                        </ul>
                    {% else %}
                        <a href="/api-auth/login/" class="log"><b>login</b></a>
                    {% endif %}
                </li>
            </ul>
        </div>
    </div>
<div class="container">
    <br/>
    <div class="panel panel-default ">
        <div class="panel-heading">
            <h3>

            <a href="{% url 'catalog:movies' %}">Movie List</a>

            {% if user.is_superuser %}
                <a href="{% url 'catalog:movielist' %}" class="btn btn-primary btn-sm pull-right" > Create </a>
            {% endif %}
            </h3>
        </div>
        <div class="panel-body">
            <table class="table table-hover table-condensed table-responsive" id="movietable">
                <thead>
                <tr >
                    <th style=" visibility: hidden;">ID</th>
                    <th>Movie Name</th>
                    <th>Director</th>
                    <th>IMDB Score</th>
                    <th>Popularity</th>
                    <th>Genres
                        {% if user.is_superuser %}
                        <a href="{% url 'catalog:genreslist' %}" class="btn btn-primary btn-xs" >Add</a>
                        {% endif %}</th>
                </tr>
                </thead>
            {% for each_movie in movielist %}
                <tr style="font-size:small;">
                    <td style=" visibility: hidden;">{{ each_movie.id }}</td>
                    <th><a href="{% url 'catalog:movieedit' each_movie.pk %}">{{ each_movie.name }}</a></th>
                <td>{{ each_movie.director }}</td>
                <td>{{ each_movie.imdb_score }}</td>
                <td>{{ each_movie.popularity }}</td>
                <td>
                    {% for each_cat in gen %}
                            <ul>
                            {% if each_cat.movie.id == each_movie.id %}
                                <li><b>
                                    {% if user.is_superuser %}
                                        <a href="{% url 'catalog:genresedit' each_cat.pk %}">
                                            {{ each_cat.category|capfirst }}
                                        </a>
                                    {% else %}
                                        <a href="{% url 'catalog:genresshow' each_cat.pk %}">
                                            {{ each_cat.category|capfirst }}
                                        </a>

                                    {% endif %}
                                </b></li>
                            {% endif %}
                            </ul>
                    {% endfor %}

                </td>
                </tr>
            {% endfor %}
            </table>
        </div>
    </div>
</div>
    </table>


</body>

</html>